      program cvthpk
      character flname*255
      parameter (nhcom=500000,nhash=5000)
      common /hcom/mm(nhcom)
      open(19,status='scratch',form='unformatted')
      if (iargc().lt.2) goto 90000
      call getarg(1,flname)
      if (flname.eq.'-h') goto 90000
      open(21,file=flname,status='old',form='unformatted',err=91000)
      call getarg(2,flname)
      open(20,file=flname,status='new',form='unformatted',err=92000)
      call nargset(4)
      call hinit(nhcom,nhash,10000,19)
      call hread('ALL ',21,0,'REPL')
      close(21)
      call hoptn('GET,HNORM',x,9999)
      call chksys(x)
      call cvtnds
      call nargset(2)
      call hwrite('ALL ',20)
      close(20)
      stop
90000 write(6,*) 'Usage:'
      write(6,*) '        cvt_hpk  <in_file>  <out_file>'
      stop 2
91000 l=index(flname,' ')-1
      write(6,*) '%%%  File Open Error (',flname(:l),')  %%%'
      write(6,*) '%%%  Check File Existence  %%%'
      stop 2
92000 l=index(flname,' ')-1
      write(6,*) '%%%  File Create Error (',flname(:l),')  %%%'
      write(6,*) '%%%  The File May Already Exist  %%%'
      stop 2
      end

      subroutine cvtnds(*)
      implicit none
      integer*4 nnodes,ihcom(2),nhcom,nodend,node1,hshloc,hshcnt,hshlen
      common /hcom/nnodes,ihcom,nhcom,nodend,node1,hshloc,hshcnt,hshlen
      integer*4 mm(1),node,mparm,mstat,msta2,mbins,mdisp,muser,ims
      real*4    rr(1)
      real*8    dd(1)
      equivalence (nnodes,mm,rr,dd)
      integer*4 id,nd,i,j,k
      node=node1
      do i=1,nnodes
         id=mm(node+4)
         nd=mm(node+5)
c        write(6,'(A,2I5,A)') ' ID:',id,nd,'-dim'
c
         mparm=mm(node+10)+node
         call cvtffl(rr(mparm+ 6))	! lowest  value of X
         call cvtffl(rr(mparm+ 7))	! width of each X bin
         call cvtffl(rr(mparm+ 8))	! highest value of X
         if (nd.eq.2) then
            call cvtffl(rr(mparm+10))	! lowest  value of Y
            call cvtffl(rr(mparm+11))	! width of each Y bin
            call cvtffl(rr(mparm+12))	! highest value of Y
         endif
c
         if (mm(node+11).ne.0) then
            mstat=mm(node+11)+node
            msta2=mstat/2
            call cvtffl(rr(mstat+ 2))	! minimum limit of X for statistics
            call cvtffl(rr(mstat+ 3))	! maximum limit of X for statistics
            call cvtffl(rr(mstat+ 4))	! lowest  X used in statistics
            call cvtffl(rr(mstat+ 5))	! highest X used in statistics
            call cvtffl(rr(mstat+ 6))	! central value X0 for moments
            call cvtgfl(dd(msta2+ 4))	! SUM 1
            call cvtgfl(dd(msta2+ 5))	! SUM W
            call cvtgfl(dd(msta2+ 6))	! SUM W*(X-X0)
            call cvtgfl(dd(msta2+ 7))	! SUM W*(X-X0)**2
            if (nd.eq.2) then
              call cvtffl(rr(mstat+16))	! minimum limit of Y for statistics
              call cvtffl(rr(mstat+17))	! maximum limit of Y for statistics
              call cvtffl(rr(mstat+18))	! lowest  Y used in statistics
              call cvtffl(rr(mstat+19))	! highest Y used in statistics
              call cvtffl(rr(mstat+20))	! central value Y0 for moments
              call cvtgfl(dd(msta2+11))	! SUM W*(Y-Y0)
              call cvtgfl(dd(msta2+12))	! SUM W*(Y-Y0)**2
              call cvtgfl(dd(msta2+13))	! SUM W*(X-X0)*(Y-Y0)
           endif
         endif
c
         ims=mm(mparm+1)
         if (mm(node+12).ne.0.and.
     &     ((ims.ge.4.and.ims.le.9).or.ims.eq.12)) then
            mbins=mm(node+12)+node
            if     (ims.eq.4) then
               k=1
            elseif (ims.eq.8) then
               k=3
            else
               k=2
            endif
            if (nd.eq.2) k=k*mm(mparm+9)
            do j=1,mm(mparm+5)*k
c           do j=1,mm(mparm+2) ! No, this contains number of calls...
               call cvtffl(rr(mbins+j))
            enddo
         endif
c
         mdisp=mm(node+14)+node
         call cvtffl(rr(mdisp+ 1))	! normalization factor
         call cvtffl(rr(mdisp+ 8))	! XMIN
         call cvtffl(rr(mdisp+ 9))	! DX
         call cvtffl(rr(mdisp+10))	! XTICS
         call cvtffl(rr(mdisp+11))	! XSUBS
         call cvtffl(rr(mdisp+12))	! YMIN
         call cvtffl(rr(mdisp+13))	! DY
         call cvtffl(rr(mdisp+14))	! YTICS
         call cvtffl(rr(mdisp+15))	! YSUBS
         if (nd.eq.2) then		! 2-dim hist
            call cvtffl(rr(mdisp+16))	! ZMIN
            call cvtffl(rr(mdisp+17))	! DZ
            call cvtffl(rr(mdisp+18))	! ZTICS
            call cvtffl(rr(mdisp+19))	! ZSUBS
            call cvtffl(rr(mdisp+20))	! ROTATION ANGLE
            call cvtffl(rr(mdisp+21))	! ELEVATION ANGLE
         endif
c
         if (mm(node+15).ne.0) then
            muser=mm(node+15)+node
            call cvtffl(rr(muser+23))	! View  x_lower
            call cvtffl(rr(muser+24))	!       x_upper
            call cvtffl(rr(muser+25))	!       y_lower (2-dim)
            call cvtffl(rr(muser+26))	!       y_upper (2-dim)
            call cvtffl(rr(muser+27))	!       z_lower
            call cvtffl(rr(muser+28))	!       z_upper
            call cvtffl(rr(muser+37))	! Cursor 1
            call cvtffl(rr(muser+38))	! Cursor 2
            call cvtffl(rr(muser+39))	! Cursor 3
            call cvtffl(rr(muser+40))	! Cursor 4
            call cvtffl(rr(muser+41))	! Cursor 5
            call cvtffl(rr(muser+42))	! Cursor 6
            call cvtffl(rr(muser+43))	! Cursor 7
            call cvtffl(rr(muser+44))	! Cursor 8
            if (nd.eq.2) then		! 2-dim hist
               call cvtffl(rr(muser+45))	! Threshold 1
               call cvtffl(rr(muser+46))	! Threshold 2
               call cvtffl(rr(muser+47))	! Threshold 3
               call cvtffl(rr(muser+48))	! Threshold 4
               call cvtffl(rr(muser+49))	! Threshold 5
               call cvtffl(rr(muser+50))	! Threshold 6
               do j=29,35,2
                  if (mm(muser+j).gt.2) then
                     do k=1,mm(muser+j+1)*2
                        call cvtffl(rr(muser+mm(muser+j)+k))
                     enddo
                  endif
               enddo
            endif
         endif
c
         node =mm(node+ 3)
      enddo
      if (node.eq.node1) return
      write(6,*) '%%%  Internal Error (Bad NODE Sequence)  %%%'
      return 1
      end
